diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/admin/cron.php mdl20-mitms-integration/admin/cron.php
--- mdl-cvshead/admin/cron.php	2009-08-25 11:49:00.000000000 +1200
+++ mdl20-mitms-integration/admin/cron.php	2009-08-25 16:20:28.000000000 +1200
@@ -245,6 +245,16 @@
     events_cron();
     mtrace('done.');
 
+
+    if ($CFG->enablecompletion) {
+        // Completion cron
+        mtrace('Starting the completion cron...');
+        require_once($CFG->libdir . '/completion/cron.php');
+        completion_cron();
+        mtrace('done');
+    }
+
+
     if ($CFG->enableportfolios) {
         // Portfolio cron
         mtrace('Starting the portfolio cron...');
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/backup/backuplib.php mdl20-mitms-integration/backup/backuplib.php
--- mdl-cvshead/backup/backuplib.php	2009-08-25 11:49:00.000000000 +1200
+++ mdl20-mitms-integration/backup/backuplib.php	2009-08-25 16:20:29.000000000 +1200
@@ -715,6 +715,7 @@
             fwrite ($bf,full_tag("ENROLENDDATE",3,false,$course->enrolenddate));
             fwrite ($bf,full_tag("ENROLPERIOD",3,false,$course->enrolperiod));
             fwrite ($bf,full_tag("ENABLECOMPLETION",3,false,$course->enablecompletion));
+            fwrite ($bf,full_tag("COMPLETIONNOTIFY",3,false,$course->completionnotify));
 
             // Write role assigns, overrides, etc.
             write_per_context_data($bf, $preferences, $context, 3);
@@ -1243,7 +1244,7 @@
                    backup_userdata_selected($preferences,$moduletype,$course_module->instance)) {
                    fwrite ($bf,start_tag("COMPLETIONDATA",6,true));
 
-                   // Get all completion records for this module and loop
+                   // Get all activity completion records for this module and loop
                    $data=$DB->get_records('course_modules_completion',array('coursemoduleid'=>$course_module->id));
                    $data=$data ? $data : array();
                    foreach($data as $completion) {
@@ -1557,6 +1558,180 @@
         return $status;
     }
 
+    //Backup course completion info
+    function backup_course_completion_info($bf, $preferences) {
+        global $CFG, $DB;
+        require_once($CFG->libdir.'/completionlib.php');
+
+        $status = true;
+
+        //Completion header
+        fwrite ($bf,start_tag("COMPLETION",2,true));
+
+        $status = backup_course_completion_aggregation_methods($bf, $preferences);
+        $status = backup_course_completion_criteria($bf, $preferences);
+        $status = backup_course_completion_notify($bf, $preferences);
+        $status = backup_course_completion_criteria_completions($bf, $preferences);
+        $status = backup_course_completion_completions($bf, $preferences);
+
+        //Completion footer
+        $status = fwrite ($bf,end_tag("COMPLETION",2,true));
+        return $status;
+    }
+
+    // Backup course completion aggregation methods
+    function backup_course_completion_aggregation_methods($bf, $preferences) {
+        global $DB;
+        $status = true;
+
+        $methods = $DB->get_records('course_completion_aggr_methd', array('course' => $preferences->backup_course));
+
+        if ($methods) {
+            //Begin completion_aggregation_methods tag
+            fwrite ($bf,start_tag("COMPLETION_AGGREGATION_METHODS",3,true));
+
+            //Iterate for each aggregation method
+            foreach ($methods as $method) {
+
+                //Begin completion_aggregation_method
+                fwrite ($bf,start_tag("COMPLETION_AGGREGATION_METHOD",4,true));
+
+                //Output individual fields
+                fwrite ($bf,full_tag("ID",5,false,$method->id));
+                fwrite ($bf,full_tag("COURSE",5,false,$method->course));
+                fwrite ($bf,full_tag("CRITERIATYPE",5,false,$method->criteriatype));
+                fwrite ($bf,full_tag("METHOD",5,false,$method->method));
+                fwrite ($bf,full_tag("VALUE",5,false,$method->value));
+
+                //End completion_aggregation_method
+                fwrite ($bf,end_tag("COMPLETION_AGGREGATION_METHOD",4,true));
+            }
+
+            //End completion_aggregation_methods tag
+            $status = fwrite ($bf,end_tag("COMPLETION_AGGREGATION_METHODS",3,true));
+        } 
+
+        return $status;
+    }
+
+    // Backup course completion criteria
+    function backup_course_completion_criteria($bf, $preferences) {
+        global $DB;
+        $status = true;
+
+        $criteria = $DB->get_records('course_completion_criteria', array('course' => $preferences->backup_course));
+
+        if ($criteria) {
+            //Begin completion_criteria tag
+            fwrite ($bf,start_tag("COMPLETION_CRITERIA",3,true));
+
+            //Iterate for each criteria
+            foreach ($criteria as $criterion) {
+
+                //Begin completion_criterion
+                fwrite ($bf,start_tag("COMPLETION_CRITERIA",4,true));
+
+                //Output individual fields
+                fwrite ($bf,full_tag("ID",5,false,$criterion->id));
+                fwrite ($bf,full_tag("COURSE",5,false,$criterion->course));
+                fwrite ($bf,full_tag("ITEMNAME",5,false,$criterion->itemname));
+                fwrite ($bf,full_tag("CRITERIATYPE",5,false,$criterion->criteriatype));
+                fwrite ($bf,full_tag("MODULE",5,false,$criterion->module));
+                fwrite ($bf,full_tag("MODULEINSTANCE",5,false,$criterion->moduleinstance));
+                fwrite ($bf,full_tag("ENROLPERIOD",5,false,$criterion->enrolperiod));
+                fwrite ($bf,full_tag("DATE",5,false,$criterion->date));
+                fwrite ($bf,full_tag("GRADEPASS",5,false,$criterion->gradepass));
+                fwrite ($bf,full_tag("ROLE",5,false,$criterion->role));
+                fwrite ($bf,full_tag("LOCK",5,false,$criterion->lock));
+
+                //End completion_criterion
+                fwrite ($bf,end_tag("COMPLETION_CRITERIA",4,true));
+            }
+
+            //End completion_criteria tag
+            $status = fwrite ($bf,end_tag("COMPLETION_CRITERIA",3,true));
+        } 
+
+        return $status;
+    }
+
+    // Backup course completion notify
+    function backup_course_completion_notify($bf, $preferences) {
+        global $DB;
+        $status = true;
+
+        $notifications = $DB->get_records('course_completion_notify', array('course' => $preferences->backup_course));
+
+        if ($notifications) {
+            //Begin completion_notify tag
+            fwrite ($bf,start_tag("COMPLETION_NOTIFY",3,true));
+
+            //Iterate for each notification
+            foreach ($notifications as $notification) {
+
+                //Begin completion_notification
+                fwrite ($bf,start_tag("COMPLETION_NOTIFICATION",4,true));
+
+                //Output individual fields
+                fwrite ($bf,full_tag("ID",5,false,$notification->id));
+                fwrite ($bf,full_tag("COURSE",5,false,$notification->course));
+                fwrite ($bf,full_tag("ROLE",5,false,$notification->role));
+                fwrite ($bf,full_tag("MESSAGE",5,false,$notification->message));
+                fwrite ($bf,full_tag("TIMESENT",5,false,$notification->timesent));
+
+                //End completion_notification
+                fwrite ($bf,end_tag("COMPLETION_NOTIFICATION",4,true));
+            }
+
+            //End completion_notify tag
+            $status = fwrite ($bf,end_tag("COMPLETION_NOTIFY",3,true));
+        } 
+
+        return $status;
+    }
+
+    //Backup course completion criteria completions
+    function backup_course_completion_criteria_completions($bf, $preferences) {
+        global $CFG, $DB;
+
+        $status = true;
+
+        // Grade all criteria completions in this course
+        if ($completions = $DB->get_records('course_completion_crit_compl', array('course' => $preferences->backup_course))) {
+
+            fwrite ($bf,start_tag("COMPLETION_CRITERIA_COMPLETIONS",5,true));
+            foreach ($grades as $grade) {
+            /// Grades are only sent to backup if the user is one target user
+                if (backup_getid($preferences->backup_unique_code, 'user', $grade->userid)) {
+                    fwrite ($bf,start_tag("GRADE",6,true));
+                    fwrite ($bf,full_tag("ID",7,false,$grade->id));
+                    fwrite ($bf,full_tag("USERID",7,false,$grade->userid));
+                    fwrite ($bf,full_tag("RAWGRADE",7,false,$grade->rawgrade));
+                    fwrite ($bf,full_tag("RAWGRADEMAX",7,false,$grade->rawgrademax));
+                    fwrite ($bf,full_tag("RAWGRADEMIN",7,false,$grade->rawgrademin));
+                    fwrite ($bf,full_tag("RAWSCALEID",7,false,$grade->rawscaleid));
+                    fwrite ($bf,full_tag("USERMODIFIED",7,false,$grade->usermodified));
+                    fwrite ($bf,full_tag("FINALGRADE",7,false,$grade->finalgrade));
+                    fwrite ($bf,full_tag("HIDDEN",7,false,$grade->hidden));
+                    fwrite ($bf,full_tag("LOCKED",7,false,$grade->locked));
+                    fwrite ($bf,full_tag("LOCKTIME",7,false,$grade->locktime));
+                    fwrite ($bf,full_tag("EXPORTED",7,false,$grade->exported));
+                    fwrite ($bf,full_tag("OVERRIDDEN",7,false,$grade->overridden));
+                    fwrite ($bf,full_tag("EXCLUDED",7,false,$grade->excluded));
+                    fwrite ($bf,full_tag("FEEDBACK",7,false,$grade->feedback));
+                    fwrite ($bf,full_tag("FEEDBACKFORMAT",7,false,$grade->feedbackformat));
+                    fwrite ($bf,full_tag("INFORMATION",7,false,$grade->information));
+                    fwrite ($bf,full_tag("INFORMATIONFORMAT",7,false,$grade->informationformat));
+                    fwrite ($bf,full_tag("TIMECREATED",7,false,$grade->timecreated));
+                    fwrite ($bf,full_tag("TIMEMODIFIED",7,false,$grade->timemodified));
+                    fwrite ($bf,end_tag("GRADE",6,true));
+                }
+            }
+            $status = fwrite ($bf,end_tag("GRADE_GRADES",5,true));
+        }
+        return $status;
+    }
+
     //Backup gradebook info
     function backup_gradebook_info($bf, $preferences) {
         global $CFG, $DB;
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/blocks/admin/block_admin.php mdl20-mitms-integration/blocks/admin/block_admin.php
--- mdl-cvshead/blocks/admin/block_admin.php	2009-07-17 09:18:13.000000000 +1200
+++ mdl20-mitms-integration/blocks/admin/block_admin.php	2009-08-25 16:20:28.000000000 +1200
@@ -41,6 +41,11 @@
 
             $this->content->items[]='<a href="'.$CFG->wwwroot.'/course/edit.php?id='.$course->id.'">'.get_string('settings').'</a>';
             $this->content->icons[]='<img src="'.$OUTPUT->old_icon_url('i/settings') . '" class="icon" alt="" />';
+
+            if (!empty($course->enablecompletion)) {
+                $this->content->items[]='<a href="'.$CFG->wwwroot.'/course/completion.php?id='.$course->id.'">'.get_string('completionmenuitem', 'completion').'</a>';
+                $this->content->icons[]='<img src="'.$OUTPUT->old_icon_url('i/settings') . '" class="icon" alt="" />';
+            }
         }
 
     /// Assign roles to the course
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/blocks/completionstatus/block_completionstatus.php mdl20-mitms-integration/blocks/completionstatus/block_completionstatus.php
--- mdl-cvshead/blocks/completionstatus/block_completionstatus.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/blocks/completionstatus/block_completionstatus.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,163 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+
+/**
+ * Block for displayed logged in user's course completion status
+ *
+ * @package   moodlecore
+ * @copyright 2009 Catalyst IT Ltd
+ * @author    Aaron Barnes <aaronb@catalyst.net.nz>
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+require_once($CFG->libdir.'/completionlib.php');
+
+/**
+ * Course completion status
+ * Displays overall, and individual criteria status for logged in user
+ */
+class block_completionstatus extends block_base {
+
+    public function init() {
+        $this->title   = get_string('completionstatus', 'block_completionstatus');
+        $this->version = 2009072800;
+    }
+
+    public function get_content() {
+        global $USER, $CFG;
+
+        // If content is cached
+        if ($this->content !== NULL) {
+            return $this->content;
+        }
+
+        // Create empty content
+        $this->content = new stdClass;
+
+        // Don't display if completion isn't enabled!
+        if (!$this->page->course->enablecompletion) {
+            return $this->content;
+        }
+
+        // Load criteria to display
+        $info = new completion_info($this->page->course);
+        $completions = $info->get_completions($USER->id);
+
+        // Check if this course has any criteria
+        if (empty($completions)) {
+            return $this->content;
+        }
+
+        // Check this user is enroled
+        $users = $info->internal_get_tracked_users(true);
+        if (!in_array($USER->id, array_keys($users))) {
+            $this->content->text = get_string('notenroled', 'completion');
+            return $this->content;
+        }
+
+        // Generate markup for criteria statuses
+        $shtml = '<tr><td><b>'.get_string('requiredcriteria', 'completion').'</b></td><td style="text-align: right"><b>'.get_string('status').'</b></td></tr>';
+
+        // For aggregating activity completion
+        $activities = array();
+        $activities_complete = 0;
+
+        // Flag to set if current completion data is inconsistent with
+        // what is stored in the database
+        $pending_update = false;
+
+        // Loop through course criteria
+        foreach ($completions as $completion) {
+
+            $criteria = $completion->get_criteria();
+            $complete = $completion->is_complete();
+
+            if (!$pending_update && $criteria->is_pending($completion)) {
+                $pending_update = true;
+            }
+
+            // Activities are a special case, so cache them and leave them till last
+            if ($criteria->criteriatype == COMPLETION_CRITERIA_TYPE_ACTIVITY) {
+                $activities[$criteria->moduleinstance] = $complete;
+
+                if ($complete) {
+                    $activities_complete++;
+                }
+
+                continue;
+            }
+
+            $shtml .= '<tr><td>';
+            $shtml .= $criteria->get_title();
+            $shtml .= '</td><td style="text-align: right">';
+            $shtml .= $completion->get_status();
+            $shtml .= '</td></tr>';
+        }
+
+        // Aggregate activities
+        if (!empty($activities)) {
+
+            $shtml .= '<tr><td>';
+            $shtml .= 'Activities complete';
+            $shtml .= '</td><td style="text-align: right">';
+            $shtml .= $activities_complete.' of '.count($activities);
+            $shtml .= '</td></tr>';
+        }
+
+        // Display completion status
+        $this->content->text  = '<table width="100%" style="font-size: 90%;"><tbody>';
+        $this->content->text .= '<tr><td colspan="2"><b>'.get_string('status').':</b> ';
+
+        // Is course complete?
+        $coursecomplete = $info->is_course_complete($USER->id);
+
+        // Has this user completed any criteria?
+        $criteriacomplete = $info->count_course_user_data($USER->id);
+
+        if ($pending_update) {
+            $this->content->text .= '<i>'.get_string('pending', 'completion').'</i>';
+        } else if ($coursecomplete) {
+            $this->content->text .= get_string('complete');
+        } else if (!$criteriacomplete) {
+            $this->content->text .= '<i>'.get_string('notyetstarted', 'completion').'</i>';
+        } else {
+            $this->content->text .= '<i>'.get_string('inprogress','completion').'</i>';
+        }
+
+        $this->content->text .= '</td></tr>';
+        $this->content->text .= '<tr><td colspan="2">';
+
+        // Get overall aggregation method
+        $overall = $info->get_aggregation_method();
+
+        if ($overall == COMPLETION_AGGREGATION_ALL) {
+            $this->content->text .= get_string('criteriarequiredall', 'completion');
+        } else {
+            $this->content->text .= get_string('criteriarequiredany', 'completion');
+        }
+
+        $this->content->text .= ':</td></tr>'.$shtml.'</tbody></table>';
+
+        // Display link to report
+        $context = get_context_instance(CONTEXT_COURSE, $this->page->course->id);
+        if (has_capability('coursereport/progress:view',$context)) {
+            $this->content->footer = '<br><a href="'.$CFG->wwwroot.'/course/report/progress/?course='.$this->page->course->id.'">More info</a>';
+        }
+
+        return $this->content;
+    }
+}
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/blocks/selfcompletion/block_selfcompletion.php mdl20-mitms-integration/blocks/selfcompletion/block_selfcompletion.php
--- mdl-cvshead/blocks/selfcompletion/block_selfcompletion.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/blocks/selfcompletion/block_selfcompletion.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,93 @@
+<?php
+
+///////////////////////////////////////////////////////////////////////////
+//                                                                       //
+// NOTICE OF COPYRIGHT                                                   //
+//                                                                       //
+// Moodle - Modular Object-Oriented Dynamic Learning Environment         //
+//          http://moodle.com                                            //
+//                                                                       //
+// Copyright (C) 1999 onwards Martin Dougiamas  http://dougiamas.com     //
+//                                                                       //
+// This program is free software; you can redistribute it and/or modify  //
+// it under the terms of the GNU General Public License as published by  //
+// the Free Software Foundation; either version 2 of the License, or     //
+// (at your option) any later version.                                   //
+//                                                                       //
+// This program is distributed in the hope that it will be useful,       //
+// but WITHOUT ANY WARRANTY; without even the implied warranty of        //
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         //
+// GNU General Public License for more details:                          //
+//                                                                       //
+//          http://www.gnu.org/copyleft/gpl.html                         //
+//                                                                       //
+///////////////////////////////////////////////////////////////////////////
+
+require_once($CFG->libdir.'/completionlib.php');
+
+/**
+ * Self course completion marking
+ * Let's a user manually complete a course
+ *
+ * Will only display if the course has completion enabled,
+ * there is a self completion criteria, and the logged in user is yet
+ * to complete the course.
+ */
+class block_selfcompletion extends block_base {
+
+    public function init() {
+        $this->title   = get_string('selfcompletion', 'block_selfcompletion');
+        $this->version = 2009072800;
+    }
+
+    public function get_content() {
+        global $USER;
+
+        // If content is cached
+        if ($this->content !== NULL) {
+          return $this->content;
+        }
+
+        global $CFG;
+
+        // Create empty content
+        $this->content = new stdClass;
+
+        // Don't display if completion isn't enabled!
+        if (!$this->page->course->enablecompletion) {
+            return $this->content;
+        }
+
+        // Get course completion data
+        $info = new completion_info($this->page->course);
+        $completion = $info->get_completion($USER->id, COMPLETION_CRITERIA_TYPE_SELF);
+
+        // Is course complete?
+        if ($info->is_course_complete($USER->id)) {
+            return $this->content;
+        }
+
+        // Check if self completion is one of this course's criteria
+        if (empty($completion)) {
+            return $this->content;
+        }
+
+        // Check this user is enroled
+        $users = $info->internal_get_tracked_users(true);
+        if (!in_array($USER->id, array_keys($users))) {
+            $this->content->text = get_string('notenroled', 'completion');
+            return $this->content;
+        }
+
+        // Check if the user has already marked themselves as complete
+        if ($completion->is_complete()) {
+            return $this->content;
+        } else {
+            $this->content->text = '';
+            $this->content->footer = '<br /><a href="'.$CFG->wwwroot.'/course/togglecompletion.php?course='.$this->page->course->id.'">'.
+                                       get_string('completecourse', 'block_selfcompletion').'</a>...';
+        }
+
+        return $this->content;
+    }
+}
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/course/completion_form.php mdl20-mitms-integration/course/completion_form.php
--- mdl-cvshead/course/completion_form.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/course/completion_form.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,157 @@
+<?php
+
+///////////////////////////////////////////////////////////////////////////
+//                                                                       //
+// NOTICE OF COPYRIGHT                                                   //
+//                                                                       //
+// Moodle - Modular Object-Oriented Dynamic Learning Environment         //
+//          http://moodle.com                                            //
+//                                                                       //
+// Copyright (C) 1999 onwards Martin Dougiamas  http://dougiamas.com     //
+//                                                                       //
+// This program is free software; you can redistribute it and/or modify  //
+// it under the terms of the GNU General Public License as published by  //
+// the Free Software Foundation; either version 2 of the License, or     //
+// (at your option) any later version.                                   //
+//                                                                       //
+// This program is distributed in the hope that it will be useful,       //
+// but WITHOUT ANY WARRANTY; without even the implied warranty of        //
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         //
+// GNU General Public License for more details:                          //
+//                                                                       //
+//          http://www.gnu.org/copyleft/gpl.html                         //
+//                                                                       //
+///////////////////////////////////////////////////////////////////////////
+
+require_once($CFG->libdir.'/formslib.php');
+
+class course_completion_form extends moodleform {
+
+    function definition() {
+        global $USER, $CFG, $DB;
+
+        $courseconfig = get_config('moodlecourse');
+        $mform    =& $this->_form;
+
+        $course   = $this->_customdata['course'];
+        $completion = new completion_info($course);
+
+        $params = array(
+            'course'  => $course->id
+        );
+
+
+/// form definition
+//--------------------------------------------------------------------------------
+
+        // Check if there is existing criteria completions
+        if ($completion->is_course_locked()) {
+            $mform->addElement('header', '', get_string('completionsettingslocked', 'completion'));
+            $mform->addElement('static', '', '', get_string('err_settingslocked', 'completion'));
+            $mform->addElement('submit', 'settingsunlock', get_string('unlockcompletiondelete', 'completion'));
+        }
+
+        // Get array of all available aggregation methods
+        $aggregation_methods = $completion->get_aggregation_methods();
+
+        // Overall criteria aggregation
+        $mform->addElement('header', 'overallcriteria', get_string('overallcriteriaaggregation', 'completion'));
+        $mform->addElement('select', 'overall_aggregation', get_string('aggregationmethod', 'completion'), $aggregation_methods);
+        $mform->setDefault('overall_aggregation', $completion->get_aggregation_method());
+
+        // Manual self completion
+        $mform->addElement('header', 'manualselfcompletion', get_string('manualselfcompletion', 'completion'));
+        $criteria = new completion_criteria_self($params);
+        $criteria->config_form_display($mform);
+
+        // Role completion criteria
+        $mform->addElement('header', 'roles', get_string('manualcompletionby', 'completion'));
+
+        $roles = get_roles_with_capability('moodle/course:markcomplete', CAP_ALLOW, get_context_instance(CONTEXT_COURSE, $course->id));
+
+        if (!empty($roles)) {
+            $mform->addElement('select', 'role_aggregation', get_string('aggregationmethod', 'completion'), $aggregation_methods);
+            $mform->setDefault('role_aggregation', $completion->get_aggregation_method(COMPLETION_CRITERIA_TYPE_ROLE));
+
+            foreach ($roles as $role) {
+                $params_a = array('role' => $role->id);
+                $criteria = new completion_criteria_role(array_merge($params, $params_a));
+                $criteria->config_form_display($mform, $role);
+            }
+        } else {
+            $mform->addElement('static', 'noroles', '', get_string('err_noroles', 'completion'));
+        }
+
+        // Activity completion criteria
+        $mform->addElement('header', 'activitiescompleted', get_string('activitiescompleted', 'completion'));
+
+        $activities = $completion->get_activities();
+        if (!empty($activities)) {
+            if (count($activities) > 1) {
+                $mform->addElement('select', 'activity_aggregation', get_string('aggregationmethod', 'completion'), $aggregation_methods);
+                $mform->setDefault('activity_aggregation', $completion->get_aggregation_method(COMPLETION_CRITERIA_TYPE_ACTIVITY));
+            }
+
+            foreach ($activities as $activity) {
+                $params_a = array('moduleinstance' => $activity->id);
+                $criteria = new completion_criteria_activity(array_merge($params, $params_a));
+                $criteria->config_form_display($mform, $activity);
+            }
+        } else {
+            $mform->addElement('static', 'noactivities', '', get_string('err_noactivities', 'completion'));
+        }
+
+        // Completion on date
+        $mform->addElement('header', 'date', get_string('date'));
+        $criteria = new completion_criteria_date($params);
+        $criteria->config_form_display($mform);
+
+        // Completion after enrolment duration
+        $mform->addElement('header', 'duration', get_string('durationafterenrolment', 'completion'));
+        $criteria = new completion_criteria_duration($params);
+        $criteria->config_form_display($mform);
+
+        // Completion on course grade
+        $mform->addElement('header', 'grade', get_string('grade'));
+
+        $course_grade = $DB->get_field('grade_items', 'gradepass', array('courseid' => $course->id, 'itemtype' => 'course'));
+        $criteria = new completion_criteria_grade($params);
+
+        // Only display criteria enable if the course has a pass grade, or criteria already is setup
+        if ($course_grade > 0 || $criteria->id) {
+            $criteria->config_form_display($mform, $course_grade);
+        } else {
+            $mform->addElement('static', 'nograde', '', get_string('err_nograde', 'completion'));
+        }
+
+        // Completion on unenrolment
+        $mform->addElement('header', 'unenrolment', get_string('unenrolment', 'completion'));
+        $criteria = new completion_criteria_unenrol($params);
+        $criteria->config_form_display($mform);
+
+
+//--------------------------------------------------------------------------------
+        $this->add_action_buttons();
+//--------------------------------------------------------------------------------
+        $mform->addElement('hidden', 'id', $course->id);
+        $mform->setType('id', PARAM_INT);
+
+        // If the criteria are locked, freeze values and submit button
+        if ($completion->is_course_locked()) {
+            $except = array('settingsunlock');
+            $mform->hardFreezeAllVisibleExcept($except);
+            $mform->addElement('cancel');
+        }
+    }
+
+
+/// perform some extra moodle validation
+    function validation($data, $files) {
+        global $DB, $CFG;
+
+        $errors = parent::validation($data, $files);
+
+        return $errors;
+    }
+}
+?>
